%{
#define YYSTYPE double  /* Tipo de la pila de datos de yacc */
%}
%token NUMBER
%left '+' '-'
%left '*' '/'
%%
lista: 
     | lista '\n' 
     | lista expre '\n' { printf("\t%lf\n",$2); }
     ;
expre: NUMBER            { $$ = $1; }
     | expre '+' expre   { $$ = $1 + $3; }
     | expre '-' expre   { $$ = $1 - $3; }
     | expre '*' expre   { $$ = $1 * $3; }
     | expre '/' expre   { $$ = $1 / $3; }
     | '(' expre ')'     { $$ = $2; }
     ;
%%
#include <stdio.h>
#include <ctype.h>

char *nom_prog;
int num_lineas=1;

main(int argc,char *argv[]) {
    nom_prog=argv[0];
    yyparse();
}

yylex() {
int c;
   while ((c=getchar())==' '||c=='\t');
   if (c==EOF) return 0;
   if (c=='.'||isdigit(c)) {
       ungetc(c,stdin);
       scanf("%lf",&yylval);
       printf("Token numero: %lf\n",yylval);
       return NUMBER;
   }
   if (c=='\n') num_lineas++;
   printf("Token caracter: %c\n",c);
   return c;
}

yyerror(char *s) {
   warning(s,(char *)0);
}

warning(char *s,char *t) {
   fprintf(stderr,"%s: %s",nom_prog,s);
   if (t) fprintf(stderr," %s",t);
   fprintf(stderr," cerca de la linea %d\n",num_lineas);
}
